#include "ADXL372_SPI.h"
#include "i2c.h"
#include "mxc_config.h"
#include "board.h"
#include <stdio.h>

int adxl372_setup(void)
{
	unsigned int regval;
	int ret;

	regval = ADXL372RegisterRead(ADXL372_DEVID);

	if (regval != ADXL372_DEVID_VAL) {
		//return -ENODEV;
	}

	/*
	 * Perform a software reset to make sure the device is in a consistent
	 * state after start up.
	 */
	ADXL372RegisterWrite(ADXL372_RESET, ADXL372_RESET_CODE);

  regval = ADXL372RegisterRead(ADXL372_POWER_CTL);
	ADXL372RegisterWrite(ADXL372_POWER_CTL, 0x0c);

//	ret = adxl372_set_op_mode(st, ADXL372_STANDBY);
//	if (ret < 0)
//		return ret;

//	/* Set threshold for activity detection to 1g */
//	ret = adxl372_set_activity_threshold(st, ADXL372_ACTIVITY,
//					     true, true, 1000);
//	if (ret < 0)
//		return ret;

//	/* Set threshold for inactivity detection to 100mg */
//	ret = adxl372_set_activity_threshold(st, ADXL372_INACTIVITY,
//					     true, true, 100);
//	if (ret < 0)
//		return ret;

//	/* Set activity processing in Looped mode */
//	ret = adxl372_set_act_proc_mode(st, ADXL372_LOOPED);
//	if (ret < 0)
//		return ret;
//  regval = ADXL372RegisterRead(ADXL372_POWER_CTL);
	ADXL372RegisterWrite(ADXL372_TIMING, 0x00);

//	ret = adxl372_set_odr(st, ADXL372_ODR_6400HZ);
//	if (ret < 0)
//		return ret;
  ADXL372RegisterWrite(ADXL372_MEASURE, 0x28+4);
//	ret = adxl372_set_bandwidth(st, ADXL372_BW_3200HZ);
//	if (ret < 0)
//		return ret;
//  ADXL372RegisterWrite(ADXL372_HPF, 0x00);

//	/* Set activity timer to 1ms */
//	ret = adxl372_set_activity_time_ms(st, 1);
//	if (ret < 0)
//		return ret;

//	/* Set inactivity timer to 10s */
//	ret = adxl372_set_inactivity_time_ms(st, 10000);
//	if (ret < 0)
//		return ret;

	ADXL372RegisterWrite(ADXL372_POWER_CTL, 0x07);
//	/* Set the mode of operation to full bandwidth measurement mode */
//	return adxl372_set_op_mode(st, ADXL372_FULL_BW_MEASUREMENT);
  return 0;
}


void ADXL372RegisterWrite(unsigned char Address, unsigned char SendValue)
{    
    unsigned char SendTemp[3];
    SendTemp[0] = Address;                 //0x0A: write register
    SendTemp[1] = SendValue;              //address byte

    
    I2C_MasterWrite(MXC_I2C1, ADXL372Device_ID<<1, SendTemp, 2, 0);
}

unsigned char ADXL372RegisterRead(unsigned char Address)
{   
    unsigned char SendTemp[3];
    unsigned char ReceiveTemp[3];
    unsigned char ReceiveValue;
    SendTemp[0] = (Address);                 //0x0A: write register
    SendTemp[1] = 0;              //address byte
    
    I2C_MasterWrite(MXC_I2C1, ADXL372Device_ID<<1, SendTemp, 1, 1);
    I2C_MasterRead(MXC_I2C1, ADXL372Device_ID<<1, ReceiveTemp, 1, 0);
	  return ReceiveValue;
}


unsigned char ADXL372RegisterRead6(int16_t *Buffer) 
{   
    unsigned char SendTemp[8];
    unsigned char ReceiveTemp[8];
    SendTemp[0] = (ADXL372_X_DATA_H);                 //0x0A: write register
    SendTemp[1] = 0;                //address byte
    SendTemp[2] = 0;
    SendTemp[3] = 0;
    SendTemp[4] = 0;
    SendTemp[5] = 0;
    
    I2C_MasterWrite(MXC_I2C1, ADXL372Device_ID<<1, SendTemp, 1, 1);
    I2C_MasterRead(MXC_I2C1, ADXL372Device_ID<<1,(unsigned char*) ReceiveTemp, 6, 0);

    Buffer[0] = ((int16_t)(((uint16_t)ReceiveTemp[0]<<8) | ReceiveTemp[1]))>>4;
    Buffer[1] = ((int16_t)(((uint16_t)ReceiveTemp[2]<<8) | ReceiveTemp[3]))>>4;
    Buffer[2] = ((int16_t)(((uint16_t)ReceiveTemp[4]<<8) | ReceiveTemp[5]))>>4;  

	  return 0;
}



