#ifndef _ADXL372_I2C_H
#define _ADXL372_I2C_H
#include "mxc_config.h"
#include "board.h"
#include "gpio.h"
#include "spi.h"
/* ADXL372 registers definition */
#define ADXL372_DEVID			0x00
#define ADXL372_DEVID_MST		0x01
#define ADXL372_PARTID			0x02
#define ADXL372_STATUS_1		0x04
#define ADXL372_STATUS_2		0x05
#define ADXL372_FIFO_ENTRIES_2		0x06
#define ADXL372_FIFO_ENTRIES_1		0x07
#define ADXL372_X_DATA_H		0x08
#define ADXL372_X_DATA_L		0x09
#define ADXL372_Y_DATA_H		0x0A
#define ADXL372_Y_DATA_L		0x0B
#define ADXL372_Z_DATA_H		0x0C
#define ADXL372_Z_DATA_L		0x0D
#define ADXL372_X_MAXPEAK_H		0x15
#define ADXL372_X_MAXPEAK_L		0x16
#define ADXL372_Y_MAXPEAK_H		0x17
#define ADXL372_Y_MAXPEAK_L		0x18
#define ADXL372_Z_MAXPEAK_H		0x19
#define ADXL372_Z_MAXPEAK_L		0x1A
#define ADXL372_OFFSET_X		0x20
#define ADXL372_OFFSET_Y		0x21
#define ADXL372_OFFSET_Z		0x22
#define ADXL372_X_THRESH_ACT_H		0x23
#define ADXL372_X_THRESH_ACT_L		0x24
#define ADXL372_Y_THRESH_ACT_H		0x25
#define ADXL372_Y_THRESH_ACT_L		0x26
#define ADXL372_Z_THRESH_ACT_H		0x27
#define ADXL372_Z_THRESH_ACT_L		0x28
#define ADXL372_TIME_ACT		0x29
#define ADXL372_X_THRESH_INACT_H	0x2A
#define ADXL372_X_THRESH_INACT_L	0x2B
#define ADXL372_Y_THRESH_INACT_H	0x2C
#define ADXL372_Y_THRESH_INACT_L	0x2D
#define ADXL372_Z_THRESH_INACT_H	0x2E
#define ADXL372_Z_THRESH_INACT_L	0x2F
#define ADXL372_TIME_INACT_H		0x30
#define ADXL372_TIME_INACT_L		0x31
#define ADXL372_X_THRESH_ACT2_H		0x32
#define ADXL372_X_THRESH_ACT2_L		0x33
#define ADXL372_Y_THRESH_ACT2_H		0x34
#define ADXL372_Y_THRESH_ACT2_L		0x35
#define ADXL372_Z_THRESH_ACT2_H		0x36
#define ADXL372_Z_THRESH_ACT2_L		0x37
#define ADXL372_HPF			0x38
#define ADXL372_FIFO_SAMPLES		0x39
#define ADXL372_FIFO_CTL		0x3A
#define ADXL372_INT1_MAP		0x3B
#define ADXL372_INT2_MAP		0x3C
#define ADXL372_TIMING			0x3D
#define ADXL372_MEASURE			0x3E
#define ADXL372_POWER_CTL		0x3F
#define ADXL372_SELF_TEST		0x40
#define ADXL372_RESET			0x41
#define ADXL372_FIFO_DATA		0x42

#define ADXL372_DEVID_VAL		0xAD
#define ADXL372_PARTID_VAL		0xFA
#define ADXL372_RESET_CODE		0x52

///* ADXL372_POWER_CTL */
////#define ADXL372_POWER_CTL_MODE_MSK		GENMASK_ULL(1, 0)
//#define ADXL372_POWER_CTL_MODE(x)		(((x) & 0x3) << 0)

///* ADXL372_MEASURE */
////#define ADXL372_MEASURE_LINKLOOP_MSK		GENMASK_ULL(5, 4)
//#define ADXL372_MEASURE_LINKLOOP_MODE(x)	(((x) & 0x3) << 4)
////#define ADXL372_MEASURE_BANDWIDTH_MSK		GENMASK_ULL(2, 0)
//#define ADXL372_MEASURE_BANDWIDTH_MODE(x)	(((x) & 0x7) << 0)

///* ADXL372_TIMING */
////#define ADXL372_TIMING_ODR_MSK			GENMASK_ULL(7, 5)
//#define ADXL372_TIMING_ODR_MODE(x)		(((x) & 0x7) << 5)

///* ADXL372_FIFO_CTL */
////#define ADXL372_FIFO_CTL_FORMAT_MSK		GENMASK(5, 3)
//#define ADXL372_FIFO_CTL_FORMAT_MODE(x)		(((x) & 0x7) << 3)
//#define ADXL372_FIFO_CTL_FORMAT_SEL(x)		(((x) >> 3) & 0x7)
////#define ADXL372_FIFO_CTL_MODE_MSK		GENMASK(2, 1)
//#define ADXL372_FIFO_CTL_MODE_MODE(x)		(((x) & 0x3) << 1)
//#define ADXL372_FIFO_CTL_SAMPLES_MSK		BIT(1)
//#define ADXL372_FIFO_CTL_SAMPLES_MODE(x)	(((x) > 0xFF) ? 1 : 0)

///* ADXL372_STATUS_1 */
//#define ADXL372_STATUS_1_DATA_RDY(x)		(((x) >> 0) & 0x1)
//#define ADXL372_STATUS_1_FIFO_RDY(x)		(((x) >> 1) & 0x1)
//#define ADXL372_STATUS_1_FIFO_FULL(x)		(((x) >> 2) & 0x1)
//#define ADXL372_STATUS_1_FIFO_OVR(x)		(((x) >> 3) & 0x1)
//#define ADXL372_STATUS_1_USR_NVM_BUSY(x)	(((x) >> 5) & 0x1)
//#define ADXL372_STATUS_1_AWAKE(x)		(((x) >> 6) & 0x1)
//#define ADXL372_STATUS_1_ERR_USR_REGS(x)	(((x) >> 7) & 0x1)

///* ADXL372_STATUS_2 */
//#define ADXL372_STATUS_2_INACT(x)		(((x) >> 4) & 0x1)
//#define ADXL372_STATUS_2_ACT(x)			(((x) >> 5) & 0x1)
//#define ADXL372_STATUS_2_AC2(x)			(((x) >> 6) & 0x1)

///* ADXL372_INT1_MAP */
//#define ADXL372_INT1_MAP_DATA_RDY_MSK		BIT(0)
//#define ADXL372_INT1_MAP_DATA_RDY_MODE(x)	(((x) & 0x1) << 0)
//#define ADXL372_INT1_MAP_FIFO_RDY_MSK		BIT(1)
//#define ADXL372_INT1_MAP_FIFO_RDY_MODE(x)	(((x) & 0x1) << 1)
//#define ADXL372_INT1_MAP_FIFO_FULL_MSK		BIT(2)
//#define ADXL372_INT1_MAP_FIFO_FULL_MODE(x)	(((x) & 0x1) << 2)
//#define ADXL372_INT1_MAP_FIFO_OVR_MSK		BIT(3)
//#define ADXL372_INT1_MAP_FIFO_OVR_MODE(x)	(((x) & 0x1) << 3)
//#define ADXL372_INT1_MAP_INACT_MSK		BIT(4)
//#define ADXL372_INT1_MAP_INACT_MODE(x)		(((x) & 0x1) << 4)
//#define ADXL372_INT1_MAP_ACT_MSK		BIT(5)
//#define ADXL372_INT1_MAP_ACT_MODE(x)		(((x) & 0x1) << 5)
//#define ADXL372_INT1_MAP_AWAKE_MSK		BIT(6)
//#define ADXL372_INT1_MAP_AWAKE_MODE(x)		(((x) & 0x1) << 6)
//#define ADXL372_INT1_MAP_LOW_MSK		BIT(7)
//#define ADXL372_INT1_MAP_LOW_MODE(x)		(((x) & 0x1) << 7)

///* ADX372_THRESH */
////#define ADXL372_THRESH_VAL_H_MSK	GENMASK(10, 3)
//#define ADXL372_THRESH_VAL_H_SEL(x)	FIELD_GET(ADXL372_THRESH_VAL_H_MSK, x)
////#define ADXL372_THRESH_VAL_L_MSK	GENMASK(2, 0)
//#define ADXL372_THRESH_VAL_L_SEL(x)	FIELD_GET(ADXL372_THRESH_VAL_L_MSK, x)

///* The ADXL372 includes a deep, 512 sample FIFO buffer */
//#define ADXL372_FIFO_SIZE			512
//#define ADXL372_X_AXIS_EN(x)			((x) & BIT(0))
//#define ADXL372_Y_AXIS_EN(x)			((x) & BIT(1))
//#define ADXL372_Z_AXIS_EN(x)			((x) & BIT(2))
#define ADXL372Device_ID  0x53
unsigned char ADXL372RegisterRead(unsigned char Address);
void          ADXL372RegisterWrite(unsigned char Address, unsigned char SendValue);
void  ADXL362BurstRead(unsigned char Address, unsigned char NumberofRegisters, unsigned char *RegisterData);
void  ADXL362BurstWrite(unsigned char Address, unsigned char NumberofRegisters, unsigned char *RegisterData);
int ADXL372_Init(void);
int adxl372_setup(void);

extern void SpiFunction(spi_type spi_name, unsigned char *OutputBuff,unsigned char *InputBuff, unsigned int NoOfBytes);
#endif
